# bash completion for 2600Hz, Inc's sup command

_sup() {
    local cur prev
    _get_comp_words_by_ref cur prev

    local path=.$(echo ${COMP_WORDS[*]} | sed 's/ /./g').
    # echo $path

    args() {
        case $path in
            .sup.kazoo_voicemail_maintenance.renotify.*) COMPREPLY=( $(compgen -W '--> [Account,MessageId] ' -- $cur) ) ;;
            .sup.kazoo_voicemail_maintenance.recover_messages_month.*) COMPREPLY=( $(compgen -W '--> [Year,Month] ' -- $cur) ) ;;
            .sup.kazoo_voicemail_maintenance.recover_messages_all.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_voicemail_maintenance.recover_messages_account.*) COMPREPLY=( $(compgen -W '--> [Account] [Account,Year,Month] ' -- $cur) ) ;;
            .sup.kazoo_voicemail_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [] [AccountJObj] [PLACEHOLDER] [AccountId,Box] [AccountId,BoxIds] [AccountId,PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.set_account_language.*) COMPREPLY=( $(compgen -W '--> [Account,Language] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.remove_empty_media_docs.*) COMPREPLY=( $(compgen -W '--> [] [AccountId] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.migrate_prompts.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.import_prompts.*) COMPREPLY=( $(compgen -W '--> [DirPath] [DirPath,Lang] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.import_prompt.*) COMPREPLY=( $(compgen -W '--> [Path] [Path,Lang] ' -- $cur) ) ;;
            .sup.kazoo_media_maintenance.fix_media_names.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_convert_maintenance.versions_in_use.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_convert_maintenance.read_tiff_info.*) COMPREPLY=( $(compgen -W '--> [File] ' -- $cur) ) ;;
            .sup.kazoo_convert_maintenance.read_metadata.*) COMPREPLY=( $(compgen -W '--> [File] ' -- $cur) ) ;;
            .sup.kazoo_convert_maintenance.convert_fax_file.*) COMPREPLY=( $(compgen -W '--> [FromFile,ToFormat] [FromFile,ToFormat,WorkDir] [FromFile,ToFormat,WorkDir,ToFilename] ' -- $cur) ) ;;
            .sup.kazoo_proper_maintenance.run_seq_modules.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_proper_maintenance.run_seq_module.*) COMPREPLY=( $(compgen -W '--> [Module] [ModuleBin] ' -- $cur) ) ;;
            .sup.kazoo_proper_maintenance.run_modules.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_proper_maintenance.run_module.*) COMPREPLY=( $(compgen -W '--> [Module] [ModuleBin] ' -- $cur) ) ;;
            .sup.kazoo_auth_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_auth_maintenance.register_common_providers.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_auth_maintenance.register_auth_app_key.*) COMPREPLY=( $(compgen -W '--> [AppId,PemFile] ' -- $cur) ) ;;
            .sup.kazoo_auth_maintenance.register_auth_app.*) COMPREPLY=( $(compgen -W '--> [AccountId,OAuthId,Secret,Provider] ' -- $cur) ) ;;
            .sup.kazoo_auth_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_auth_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_auth_maintenance.ensure_secret.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_endpoint_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_ledgers_maintenance.verify_rollovers.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.kazoo_ledgers_maintenance.verify_all_rollovers.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_ledgers_maintenance.rollover_accounts.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_ledgers_maintenance.rollover_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_ledgers_maintenance.fix_rollovers.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER] [[MODb|MODbs]] [[]] ' -- $cur) ) ;;
            .sup.kazoo_ledgers_maintenance.fix_rollover.*) COMPREPLY=( $(compgen -W '--> [Account,Year,Month] ' -- $cur) ) ;;
            .sup.kazoo_ledgers_maintenance.current_rollovers.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_schemas_maintenance.diff_schemas.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_schemas_maintenance.diff_schema.*) COMPREPLY=( $(compgen -W '--> [Schema] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.update_tree.*) COMPREPLY=( $(compgen -W '--> [Account,NewTree,NewResellerId] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.topup_status.*) COMPREPLY=( $(compgen -W '--> [] [AccountId] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.sync_descendants.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.sync.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.set_reseller_id.*) COMPREPLY=( $(compgen -W '--> [Reseller,Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.remove_orphaned_services.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.reconcile.*) COMPREPLY=( $(compgen -W '--> [] ['all'] [Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.rebuild_services_db.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.migrate_services.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.migrate_service_plans.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.migrate_service_plan.*) COMPREPLY=( $(compgen -W '--> [AccountDb,JObj] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.make_reseller.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.get_accounts_with_plans.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.get_accounts_by_depth.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.fix_plan_apps.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.enable_topup.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.disable_topup.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.demote_reseller.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.db_init.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.cascade_reseller_id.*) COMPREPLY=( $(compgen -W '--> [Reseller,Account] ' -- $cur) ) ;;
            .sup.kazoo_services_maintenance.attempt_services_recovery.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_speech_maintenance.set_tts_provider.*) COMPREPLY=( $(compgen -W '--> [Provider] ' -- $cur) ) ;;
            .sup.kazoo_speech_maintenance.set_tts_language.*) COMPREPLY=( $(compgen -W '--> [Language] ' -- $cur) ) ;;
            .sup.kazoo_speech_maintenance.set_tts_api_key.*) COMPREPLY=( $(compgen -W '--> [Provider,APIKey] ' -- $cur) ) ;;
            .sup.kazoo_perf_maintenance.json_metrics.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_perf_maintenance.graphite_metrics.*) COMPREPLY=( $(compgen -W '--> [Account,Cluster,Zone] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.terminate.*) COMPREPLY=( $(compgen -W '--> [_Reason,PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.stop.*) COMPREPLY=( $(compgen -W '--> [Srv] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.start_link.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.register_oauth_app.*) COMPREPLY=( $(compgen -W '--> [AccountId,OAuthId,EMail,Secret,Provider] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.register_common_providers.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] [oauth] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.init.*) COMPREPLY=( $(compgen -W '--> [[]] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.handle_info.*) COMPREPLY=( $(compgen -W '--> [_Info,_State] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.handle_cast.*) COMPREPLY=( $(compgen -W '--> ['stop',State] [_Msg,State] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.handle_call.*) COMPREPLY=( $(compgen -W '--> [_Any,_From,PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_oauth_maintenance.code_change.*) COMPREPLY=( $(compgen -W '--> [_OldVsn,State,_Extra] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.top_mem_consumers.*) COMPREPLY=( $(compgen -W '--> [] [Len] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.syslog_level.*) COMPREPLY=( $(compgen -W '--> [Level] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.mem_info.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.hotload_app.*) COMPREPLY=( $(compgen -W '--> [App] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.hotload.*) COMPREPLY=( $(compgen -W '--> [Module] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.gc_top_mem_consumers.*) COMPREPLY=( $(compgen -W '--> [] [N] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.gc_pids.*) COMPREPLY=( $(compgen -W '--> [Ps] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.gc_all.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.ets_info.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.etop.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.error_level.*) COMPREPLY=( $(compgen -W '--> [Level] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.debug_dump.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.crash.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_maintenance.console_level.*) COMPREPLY=( $(compgen -W '--> [Level] ' -- $cur) ) ;;
            .sup.kazoo_modb_migrate_maintenance.migrate_voicemails.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_modb_migrate_maintenance.migrate_cdrs.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_modb_migrate_maintenance.migrate_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_modb_migrate_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_modb_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_modb_maintenance.delete_modbs.*) COMPREPLY=( $(compgen -W '--> [Period] [Period,ShouldArchive] ' -- $cur) ) ;;
            .sup.kazoo_modb_maintenance.archive_modbs.*) COMPREPLY=( $(compgen -W '--> [] [AccountId] ' -- $cur) ) ;;
            .sup.kapps_controller.unbinding_fetch_app.*) COMPREPLY=( $(compgen -W '--> [Module,Function] [Module,Function,Payload] ' -- $cur) ) ;;
            .sup.kapps_controller.stop_app.*) COMPREPLY=( $(compgen -W '--> [App] ' -- $cur) ) ;;
            .sup.kapps_controller.start_which_kapps.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_controller.start_link.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_controller.start_default_apps.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_controller.start_app.*) COMPREPLY=( $(compgen -W '--> [App] ' -- $cur) ) ;;
            .sup.kapps_controller.running_apps.*) COMPREPLY=( $(compgen -W '--> [] [Verbose] ' -- $cur) ) ;;
            .sup.kapps_controller.restart_app.*) COMPREPLY=( $(compgen -W '--> [App] ' -- $cur) ) ;;
            .sup.kapps_controller.ready.*) COMPREPLY=( $(compgen -W '--> [] [Verbose] ' -- $cur) ) ;;
            .sup.kapps_controller.list_apps.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_controller.binding_fetch_app.*) COMPREPLY=( $(compgen -W '--> [Module,Function] [Module,Function,Payload] ' -- $cur) ) ;;
            .sup.kapps_maintenance.validate_system_configs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.validate_system_config.*) COMPREPLY=( $(compgen -W '--> [Id] ' -- $cur) ) ;;
            .sup.kapps_maintenance.unbind.*) COMPREPLY=( $(compgen -W '--> [Event,M,F] ' -- $cur) ) ;;
            .sup.kapps_maintenance.remove_deprecated_databases.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.remove_aggregated_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] [App] [PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kapps_maintenance.register_system_dbs_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.register_account_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.refresh_system_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.refresh_account_db.*) COMPREPLY=( $(compgen -W '--> [Database] ' -- $cur) ) ;;
            .sup.kapps_maintenance.refresh_account.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.kapps_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] [Database] ' -- $cur) ) ;;
            .sup.kapps_maintenance.rebuild_db.*) COMPREPLY=( $(compgen -W '--> [Database] [Database,Pause] ' -- $cur) ) ;;
            .sup.kapps_maintenance.read_all_account_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.purge_doc_type.*) COMPREPLY=( $(compgen -W '--> [Type,Account] [[Type|Types],Account] [[],_Account] [Type,Account,ChunkSize] ' -- $cur) ) ;;
            .sup.kapps_maintenance.parallel_migrate_modbs_ranged.*) COMPREPLY=( $(compgen -W '--> [Workers,Start] [Workers,Pause,Start] [Workers,Pause,Start,End] ' -- $cur) ) ;;
            .sup.kapps_maintenance.parallel_migrate_modbs.*) COMPREPLY=( $(compgen -W '--> [Workers] [Workers,Pause] ' -- $cur) ) ;;
            .sup.kapps_maintenance.parallel_migrate.*) COMPREPLY=( $(compgen -W '--> [Workers] [Workers,Pause] ' -- $cur) ) ;;
            .sup.kapps_maintenance.migrate_to_4_0.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.migrate_system.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.migrate_modbs_ranged.*) COMPREPLY=( $(compgen -W '--> [Start] [Pause,Start] [Pause,Start,End] ' -- $cur) ) ;;
            .sup.kapps_maintenance.migrate_modbs.*) COMPREPLY=( $(compgen -W '--> [] [Pause] ' -- $cur) ) ;;
            .sup.kapps_maintenance.migrate_media.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.migrate_limits.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [] [Pause] ' -- $cur) ) ;;
            .sup.kapps_maintenance.maybe_delete_db.*) COMPREPLY=( $(compgen -W '--> [Database] ' -- $cur) ) ;;
            .sup.kapps_maintenance.init_system.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.import_account.*) COMPREPLY=( $(compgen -W '--> [Account,Parent] ' -- $cur) ) ;;
            .sup.kapps_maintenance.get_all_account_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.flush_getby_cache.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.flush_account_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.find_invalid_acccount_dbs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_tree_accounts_dry_run.*) COMPREPLY=( $(compgen -W '--> [] [Accounts] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_tree_accounts.*) COMPREPLY=( $(compgen -W '--> [] [Accounts] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_tree_account_dry_run.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_tree_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_reseller_id_services.*) COMPREPLY=( $(compgen -W '--> [AccountId,ResellerId] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_reseller_id_accounts.*) COMPREPLY=( $(compgen -W '--> [] [Accounts] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_reseller_id_account.*) COMPREPLY=( $(compgen -W '--> [Account] [Account,ResellerId] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_aggregates.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_aggregate_faxboxes.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_aggregate_faxbox.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_aggregate_devices.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_aggregate_device.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_aggregate_accounts.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_aggregate_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.ensure_aggregate.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.cleanup_voicemail_media.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.cleanup_system_configs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.cleanup_system_config.*) COMPREPLY=( $(compgen -W '--> [Id] ' -- $cur) ) ;;
            .sup.kapps_maintenance.cleanup_orphan_modbs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.cleanup_aggregated_devices.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.cleanup_aggregated_device.*) COMPREPLY=( $(compgen -W '--> [DocId] ' -- $cur) ) ;;
            .sup.kapps_maintenance.cleanup_aggregated_accounts.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.cleanup_aggregated_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_maintenance.check_system_configs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.check_system_config.*) COMPREPLY=( $(compgen -W '--> [SystemConfig] ' -- $cur) ) ;;
            .sup.kapps_maintenance.check_release.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_maintenance.call_id_status.*) COMPREPLY=( $(compgen -W '--> [CallId] [CallId,Verbose] ' -- $cur) ) ;;
            .sup.kapps_maintenance.binding.*) COMPREPLY=( $(compgen -W '--> ['migrate'] ['refresh'] ['refresh_account'] ['register_views'] [PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kapps_maintenance.bind_and_register_views.*) COMPREPLY=( $(compgen -W '--> [_AppName,Module,Function] ' -- $cur) ) ;;
            .sup.kapps_maintenance.bind.*) COMPREPLY=( $(compgen -W '--> [Event,M,F] ' -- $cur) ) ;;
            .sup.kapps_account_config.set_global.*) COMPREPLY=( $(compgen -W '--> [Account,Category,Key,Value] ' -- $cur) ) ;;
            .sup.kapps_account_config.set.*) COMPREPLY=( $(compgen -W '--> [Account,Category,Key,Value] ' -- $cur) ) ;;
            .sup.kapps_account_config.migrate.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kapps_account_config.get_with_strategy.*) COMPREPLY=( $(compgen -W '--> [Strategy,Account,Category,Key] [Strategy,Account,Category,Key,Default] ' -- $cur) ) ;;
            .sup.kapps_account_config.get_pos_integer.*) COMPREPLY=( $(compgen -W '--> [Account,Category,Path] [Account,Category,Path,Default] ' -- $cur) ) ;;
            .sup.kapps_account_config.get_ne_binary.*) COMPREPLY=( $(compgen -W '--> [Account,Category,Path] [Account,Category,Path,Default] ' -- $cur) ) ;;
            .sup.kapps_account_config.get_ne_binaries.*) COMPREPLY=( $(compgen -W '--> [Account,Category,Path] [Account,Category,Path,Default] ' -- $cur) ) ;;
            .sup.kapps_account_config.get_hierarchy.*) COMPREPLY=( $(compgen -W '--> [Account,Category,Key] [Account,Category,Key,Default] ' -- $cur) ) ;;
            .sup.kapps_account_config.get_global.*) COMPREPLY=( $(compgen -W '--> [Account,Category] [Account,Category,Key] [Account,Category,Key,Default] ' -- $cur) ) ;;
            .sup.kapps_account_config.get_from_reseller.*) COMPREPLY=( $(compgen -W '--> [Account,Category,Key] [Account,Category,Key,Default] ' -- $cur) ) ;;
            .sup.kapps_account_config.get.*) COMPREPLY=( $(compgen -W '--> [Account,Category] [Account,Category,Key] [Account,Category,Key,Default] ' -- $cur) ) ;;
            .sup.kapps_account_config.flush_all_strategies.*) COMPREPLY=( $(compgen -W '--> [Account,Category] ' -- $cur) ) ;;
            .sup.kapps_account_config.flush.*) COMPREPLY=( $(compgen -W '--> [Account,Category] [Account,Category,Strategy] ' -- $cur) ) ;;
            .sup.kapps_config.update_default.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value] [Category,Key,Value,Options] ' -- $cur) ) ;;
            .sup.kapps_config.set_string.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value] ' -- $cur) ) ;;
            .sup.kapps_config.set_node.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value,Node] [Category,_,_,'undefined'] ' -- $cur) ) ;;
            .sup.kapps_config.set_json.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value] ' -- $cur) ) ;;
            .sup.kapps_config.set_integer.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value] ' -- $cur) ) ;;
            .sup.kapps_config.set_float.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value] ' -- $cur) ) ;;
            .sup.kapps_config.set_default.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value] ' -- $cur) ) ;;
            .sup.kapps_config.set_boolean.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value] ' -- $cur) ) ;;
            .sup.kapps_config.set.*) COMPREPLY=( $(compgen -W '--> [Category,Key,Value] [Category,Key,Value,Node] ' -- $cur) ) ;;
            .sup.kapps_config.migrate.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_config.lock_db.*) COMPREPLY=( $(compgen -W '--> [] ['false'] ['true'] [Value] ' -- $cur) ) ;;
            .sup.kapps_config.is_true.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] ' -- $cur) ) ;;
            .sup.kapps_config.is_locked.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kapps_config.get_string.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_pos_integer.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_non_neg_integer.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_node_value.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] [Category,Keys,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_ne_binary_or_ne_binaries.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_ne_binary.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_ne_binaries.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_jsons.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_json.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_is_true.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_is_false.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_integer.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_float.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_current.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,'undefined'] [Category,Key,Default,Node] [Category,Keys,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_category.*) COMPREPLY=( $(compgen -W '--> [Category] ' -- $cur) ) ;;
            .sup.kapps_config.get_boolean.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_binary.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_atom.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.get_all_kvs.*) COMPREPLY=( $(compgen -W '--> [Category] ' -- $cur) ) ;;
            .sup.kapps_config.get.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,'undefined'] [Category,Key,Default,Node] [Category,Keys,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.flush.*) COMPREPLY=( $(compgen -W '--> [] [Category] [Category,Key] [Category,Key,"undefined"] [Category,Key,'undefined'] [Category,Key,Node] [Category,Keys,Node] ' -- $cur) ) ;;
            .sup.kapps_config.fetch_current.*) COMPREPLY=( $(compgen -W '--> [Category,Key] [Category,Key,Default] [Category,Key,Default,'undefined'] [Category,Key,Default,Node] [Category,Keys,Default,Node] ' -- $cur) ) ;;
            .sup.kapps_config.fetch_category.*) COMPREPLY=( $(compgen -W '--> [Category] [Category,'false'] [Category,'true'] ' -- $cur) ) ;;
            .sup.kazoo_apps_maintenance.stop.*) COMPREPLY=( $(compgen -W '--> [Application] ' -- $cur) ) ;;
            .sup.kazoo_apps_maintenance.start.*) COMPREPLY=( $(compgen -W '--> [Application] ' -- $cur) ) ;;
            .sup.kazoo_apps_maintenance.restart.*) COMPREPLY=( $(compgen -W '--> [Application] ' -- $cur) ) ;;
            .sup.kazoo_apps_maintenance.ready.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_apps_maintenance.make_autostart_distinct.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_apps_maintenance.check.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_ips_maintenance.summary.*) COMPREPLY=( $(compgen -W '--> [] [Host] ' -- $cur) ) ;;
            .sup.kazoo_ips_maintenance.release.*) COMPREPLY=( $(compgen -W '--> [] [IP] ' -- $cur) ) ;;
            .sup.kazoo_ips_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_ips_maintenance.delete.*) COMPREPLY=( $(compgen -W '--> [] [IP] ' -- $cur) ) ;;
            .sup.kazoo_ips_maintenance.assign.*) COMPREPLY=( $(compgen -W '--> [] [IP,Account] ' -- $cur) ) ;;
            .sup.kazoo_ips_maintenance.add.*) COMPREPLY=( $(compgen -W '--> [] [IPAddress,Zone,Host] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.trace_pid.*) COMPREPLY=( $(compgen -W '--> [Pid] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.trace_module.*) COMPREPLY=( $(compgen -W '--> [Module] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.trace_function.*) COMPREPLY=( $(compgen -W '--> [Function] [Module,Function] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.stop_trace.*) COMPREPLY=( $(compgen -W '--> [Ref] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.set_cache_strategy.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER] [Strategy] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.open_document_cached.*) COMPREPLY=( $(compgen -W '--> [Db,Id] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.open_document.*) COMPREPLY=( $(compgen -W '--> [Db,Id] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.load_doc_from_file.*) COMPREPLY=( $(compgen -W '--> [Db,FilePath] [Db,_FilePath] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.flush_docs.*) COMPREPLY=( $(compgen -W '--> [] [Account] [Account,DocId] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.flush_data_plans.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.dataplan_reload.*) COMPREPLY=( $(compgen -W '--> [] [AccountId] ' -- $cur) ) ;;
            .sup.kazoo_data_maintenance.cache_strategy.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.update_number_services_view.*) COMPREPLY=( $(compgen -W '--> [AccountId] [PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.reset_allowed_features_to_defaults_on_system_config.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.remove_wrong_assigned_from_single_accountdb.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.remove_wrong_assigned_from_accounts.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.remove_denied_feature_on_reseller_of.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,AccountId] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.remove_denied_feature_on_number.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.remove_allowed_feature_on_system_config.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.remove_allowed_feature_on_reseller_of.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,AccountId] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.remove_allowed_feature_on_number.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.refresh_numbers_dbs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.refresh_numbers_db.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER] [_Thing] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.purge_discovery.*) COMPREPLY=( $(compgen -W '--> [] [Prefix] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.purge_deleted.*) COMPREPLY=( $(compgen -W '--> [] [Prefix] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.migrate_unassigned_numbers.*) COMPREPLY=( $(compgen -W '--> [] [Number] [PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.migrate_port_requests.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.init_dbs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.generate_numbers.*) COMPREPLY=( $(compgen -W '--> [Type,AccountId,StartingNumber,Quantity] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.generate_js_classifiers.*) COMPREPLY=( $(compgen -W '--> [FunMatchBlock] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.fix_apps_in_number_dbs_for_single_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.fix_apps_in_number_dbs_for_accounts.*) COMPREPLY=( $(compgen -W '--> [Accounts] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.fix_apps_for_single_number_db.*) COMPREPLY=( $(compgen -W '--> [NumberDb] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.fix_apps_for_single_account_db.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.fix_apps_for_number_dbs.*) COMPREPLY=( $(compgen -W '--> [] [NumberDbs] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.fix_apps_for_account_dbs.*) COMPREPLY=( $(compgen -W '--> [] [AccountDbs] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.fix_account_db_numbers.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.feature_permissions_on_system_config.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.feature_permissions_on_reseller_of.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.feature_permissions_on_number.*) COMPREPLY=( $(compgen -W '--> [Num] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.ensure_adminonly_features_are_reachable.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.delete.*) COMPREPLY=( $(compgen -W '--> [Num] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.copy_single_number_to_account_db.*) COMPREPLY=( $(compgen -W '--> [Num,Account] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.copy_single_number_db_to_accounts.*) COMPREPLY=( $(compgen -W '--> [NumberDb] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.copy_single_assigned_number_db_to_account.*) COMPREPLY=( $(compgen -W '--> [Account,NumberDb] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.copy_single_account_to_number_dbs.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.copy_number_dbs_to_accounts.*) COMPREPLY=( $(compgen -W '--> [] [NumberDbs] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.copy_assigned_number_dbs_to_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.copy_accounts_to_number_dbs.*) COMPREPLY=( $(compgen -W '--> [] [AccountIds] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.convert_carrier_module_number.*) COMPREPLY=( $(compgen -W '--> [Num,Target] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.convert_carrier_module.*) COMPREPLY=( $(compgen -W '--> [Source,Target] [Source,Target,Prefix] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.carrier_module_usage.*) COMPREPLY=( $(compgen -W '--> [] [Prefix] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.app_using.*) COMPREPLY=( $(compgen -W '--> [Num,AccountDb] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.all_features.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.add_denied_feature_on_reseller_of.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,AccountId] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.add_denied_feature_on_number.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.add_allowed_feature_on_system_config.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.add_allowed_feature_on_reseller_of.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,AccountId] ' -- $cur) ) ;;
            .sup.kazoo_number_manager_maintenance.add_allowed_feature_on_number.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,PLACEHOLDER] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.validate_assignments.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.remove_broker.*) COMPREPLY=( $(compgen -W '--> [Broker] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.primary_broker.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.gc_pools.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.gc_pool.*) COMPREPLY=( $(compgen -W '--> [Pool] [PoolBin] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.consumer_details.*) COMPREPLY=( $(compgen -W '--> [] [ProcessUpper] [NodeNumber,ProcessUpper,ProcessLower] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.connection_summary.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.channel_summary.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.broker_summary.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.add_connection.*) COMPREPLY=( $(compgen -W '--> [Broker] [Broker,Zone] ' -- $cur) ) ;;
            .sup.kazoo_amqp_maintenance.add_broker.*) COMPREPLY=( $(compgen -W '--> [Broker] [Broker,Zone] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.subscribe.*) COMPREPLY=( $(compgen -W '--> [Realm,User] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.send_mwi_update.*) COMPREPLY=( $(compgen -W '--> [User,New,Saved] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.reset_zone.*) COMPREPLY=( $(compgen -W '--> [] [Zone] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.reset_subscription.*) COMPREPLY=( $(compgen -W '--> [User] [User,Realm] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.reset_subscriber.*) COMPREPLY=( $(compgen -W '--> [User] [User,Realm] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.reset_server.*) COMPREPLY=( $(compgen -W '--> [Server] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.reset_realm.*) COMPREPLY=( $(compgen -W '--> [Realm] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.reset_cluster.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.reset_account.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.current_subscriptions.*) COMPREPLY=( $(compgen -W '--> [] [Realm] [Realm,User] ' -- $cur) ) ;;
            .sup.omnipresence_maintenance.count_current_subscriptions.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.test_sbc_ip.*) COMPREPLY=( $(compgen -W '--> [IP] [IP,Node] [IP,[Node|Nodes]] [_,[]] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.test_carrier_ip.*) COMPREPLY=( $(compgen -W '--> [IP] [IP,Node] [IP,[Node|Nodes]] [_,[]] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.sync_conferences.*) COMPREPLY=( $(compgen -W '--> [] [Node] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.sync_channels.*) COMPREPLY=( $(compgen -W '--> [] [Node] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.show_channels.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.show_calls.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.sbc_acls.*) COMPREPLY=( $(compgen -W '--> [] ['false'] ['true'] [AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.remove_fs_node.*) COMPREPLY=( $(compgen -W '--> [FSNode] [FSNode,'false'] [FSNode,'true'] [FSNode,AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.remove_acl.*) COMPREPLY=( $(compgen -W '--> [Name] [Name,'false'] [Name,'true'] [Name,AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.reload_acls.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.registrar_sync.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.registrar_summary.*) COMPREPLY=( $(compgen -W '--> [] [Realm] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.registrar_details.*) COMPREPLY=( $(compgen -W '--> [] [Realm] [Username,Realm] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.node_summary.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.node_details.*) COMPREPLY=( $(compgen -W '--> [] [NodeName] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.list_fs_nodes.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.limit_channel_uptime.*) COMPREPLY=( $(compgen -W '--> [MaxAge] [MaxAge,AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.hangup_long_running_channels.*) COMPREPLY=( $(compgen -W '--> [] [MaxAge] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.get_fs_nodes.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.flush_util.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.flush_registrar.*) COMPREPLY=( $(compgen -W '--> [] [Realm] [Username,Realm] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.flush_node_conferences.*) COMPREPLY=( $(compgen -W '--> [Node] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.flush_node_channels.*) COMPREPLY=( $(compgen -W '--> [Node] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.flush_authn.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.flush_acls.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.enable_local_resource_authz.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.enable_authz.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.disable_local_resource_authz.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.disable_authz.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.deny_sbc.*) COMPREPLY=( $(compgen -W '--> [Name] [Name,IP] [Name,IP,'false'] [Name,IP,'true'] [Name,IP,AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.deny_carrier.*) COMPREPLY=( $(compgen -W '--> [Name] [Name,IP] [Name,IP,'false'] [Name,IP,'true'] [Name,IP,AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.conference_summary.*) COMPREPLY=( $(compgen -W '--> [] [Node] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.conference_details.*) COMPREPLY=( $(compgen -W '--> [] [UUID] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.check_sync.*) COMPREPLY=( $(compgen -W '--> [Username,Realm] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.channel_summary.*) COMPREPLY=( $(compgen -W '--> [] [Node] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.channel_details.*) COMPREPLY=( $(compgen -W '--> [] [UUID] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.carrier_acls.*) COMPREPLY=( $(compgen -W '--> [] ['false'] ['true'] [AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.allow_sbc.*) COMPREPLY=( $(compgen -W '--> [Name] [Name,IP] [Name,IP,'false'] [Name,IP,'true'] [Name,IP,AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.allow_carrier.*) COMPREPLY=( $(compgen -W '--> [Name] [Name,IP] [Name,IP,'false'] [Name,IP,'true'] [Name,IP,AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.add_fs_node.*) COMPREPLY=( $(compgen -W '--> [FSNode] [FSNode,'false'] [FSNode,'true'] [FSNode,AsDefault] ' -- $cur) ) ;;
            .sup.ecallmgr_maintenance.acl_summary.*) COMPREPLY=( $(compgen -W '--> [] ['false'] ['true'] [AsDefault] ' -- $cur) ) ;;
            .sup.fax_maintenance.update_job.*) COMPREPLY=( $(compgen -W '--> [JobID,State] ' -- $cur) ) ;;
            .sup.fax_maintenance.restart_job.*) COMPREPLY=( $(compgen -W '--> [JobID] ' -- $cur) ) ;;
            .sup.fax_maintenance.refresh_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.fax_maintenance.pending_jobs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.fax_maintenance.migrate_outbound_faxes.*) COMPREPLY=( $(compgen -W '--> [] [Number] [Options] ' -- $cur) ) ;;
            .sup.fax_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [] [override_existing_documents] [Account] [[Account|Accounts]] [[]] [Account,Options] [Accounts,"override_existing_documents"] [Accounts,Option] [[Account|Accounts],Options] [[],_] ' -- $cur) ) ;;
            .sup.fax_maintenance.load_smtp_attachment.*) COMPREPLY=( $(compgen -W '--> [DocId,Filename] ' -- $cur) ) ;;
            .sup.fax_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.fax_maintenance.faxbox_jobs.*) COMPREPLY=( $(compgen -W '--> [FaxboxId] [FaxboxId,State] ' -- $cur) ) ;;
            .sup.fax_maintenance.active_jobs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.fax_maintenance.account_jobs.*) COMPREPLY=( $(compgen -W '--> [AccountId] [AccountId,State] ' -- $cur) ) ;;
            .sup.jonny5_maintenance.limits_summary.*) COMPREPLY=( $(compgen -W '--> [] [AccountId] [[Limit|Limits]] [[]] ' -- $cur) ) ;;
            .sup.jonny5_maintenance.limits_details.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.jonny5_maintenance.flush_channels.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.jonny5_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.jonny5_maintenance.authz_summary.*) COMPREPLY=( $(compgen -W '--> [] [PLACEHOLDER] [[AccountId|AccountIds]] [[]] ' -- $cur) ) ;;
            .sup.jonny5_maintenance.authz_details.*) COMPREPLY=( $(compgen -W '--> [AccountId] [[Channel|Channels]] [[]] ' -- $cur) ) ;;
            .sup.frontier_maintenance.update_system_default.*) COMPREPLY=( $(compgen -W '--> [Path,Value] ' -- $cur) ) ;;
            .sup.frontier_maintenance.lookup_rate_limits.*) COMPREPLY=( $(compgen -W '--> [Entity] ' -- $cur) ) ;;
            .sup.frontier_maintenance.lookup_acls.*) COMPREPLY=( $(compgen -W '--> [Entity] ' -- $cur) ) ;;
            .sup.call_inspector_maintenance.stop_active_parser.*) COMPREPLY=( $(compgen -W '--> [Id] ' -- $cur) ) ;;
            .sup.call_inspector_maintenance.start_kamailio_parser.*) COMPREPLY=( $(compgen -W '--> [Filename,LogIP,LogPort] ' -- $cur) ) ;;
            .sup.call_inspector_maintenance.start_hep_parser.*) COMPREPLY=( $(compgen -W '--> [IP,Port] ' -- $cur) ) ;;
            .sup.call_inspector_maintenance.start_freeswitch_parser.*) COMPREPLY=( $(compgen -W '--> [Filename,LogIP,LogPort] ' -- $cur) ) ;;
            .sup.call_inspector_maintenance.list_active_parsers.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.call_inspector_maintenance.inspect_call_id.*) COMPREPLY=( $(compgen -W '--> [CallId] ' -- $cur) ) ;;
            .sup.call_inspector_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] [CallId] ' -- $cur) ) ;;
            .sup.call_inspector_maintenance.callid_details.*) COMPREPLY=( $(compgen -W '--> [CallId] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.reverse_lookup.*) COMPREPLY=( $(compgen -W '--> [Thing] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.resources.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.reload_resources.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.process_number.*) COMPREPLY=( $(compgen -W '--> [Number] [Num,'undefined'] [Num,AccountId] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.number_tree.*) COMPREPLY=( $(compgen -W '--> [DID] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.lookup_number.*) COMPREPLY=( $(compgen -W '--> [Number] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.stepswitch_maintenance.cnam_flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.edr_maintenance.restart_backend.*) COMPREPLY=( $(compgen -W '--> [Name] ' -- $cur) ) ;;
            .sup.edr_maintenance.registered_backends.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.edr_maintenance.register_backend.*) COMPREPLY=( $(compgen -W '--> [Name] [Name,Type] [Name,Type,Opts] [Name,Type,Opts,Bindings] [Name,Type,Opts,Bindings,Enabled] ' -- $cur) ) ;;
            .sup.edr_maintenance.enable_backend.*) COMPREPLY=( $(compgen -W '--> [Name] ' -- $cur) ) ;;
            .sup.edr_maintenance.disable_backend.*) COMPREPLY=( $(compgen -W '--> [Name] ' -- $cur) ) ;;
            .sup.edr_maintenance.delete_backend.*) COMPREPLY=( $(compgen -W '--> [Name] ' -- $cur) ) ;;
            .sup.notify_maintenance.reload_smtp_configs.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.notify_maintenance.refresh_template.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.notify_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.notify_maintenance.configure_smtp_username.*) COMPREPLY=( $(compgen -W '--> [Value] ' -- $cur) ) ;;
            .sup.notify_maintenance.configure_smtp_relay.*) COMPREPLY=( $(compgen -W '--> [Value] ' -- $cur) ) ;;
            .sup.notify_maintenance.configure_smtp_port.*) COMPREPLY=( $(compgen -W '--> [Value] ' -- $cur) ) ;;
            .sup.notify_maintenance.configure_smtp_password.*) COMPREPLY=( $(compgen -W '--> [Value] ' -- $cur) ) ;;
            .sup.notify_maintenance.configure_smtp_auth.*) COMPREPLY=( $(compgen -W '--> [Value] ' -- $cur) ) ;;
            .sup.notify_maintenance.check_initial_registration.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.notify_maintenance.check_initial_call.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.trunkstore_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.trunkstore_maintenance.clear_old_calls.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.trunkstore_maintenance.classifier_inherit.*) COMPREPLY=( $(compgen -W '--> [Classifier,UserR] ' -- $cur) ) ;;
            .sup.trunkstore_maintenance.classifier_deny.*) COMPREPLY=( $(compgen -W '--> [Classifier,UserR] ' -- $cur) ) ;;
            .sup.teletype_maintenance.stop_module.*) COMPREPLY=( $(compgen -W '--> [Module] ' -- $cur) ) ;;
            .sup.teletype_maintenance.start_module.*) COMPREPLY=( $(compgen -W '--> [Module] ' -- $cur) ) ;;
            .sup.teletype_maintenance.restore_system_templates.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.teletype_maintenance.restore_system_template.*) COMPREPLY=( $(compgen -W '--> [skel] [TemplateId] ' -- $cur) ) ;;
            .sup.teletype_maintenance.renderer_status.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.teletype_maintenance.remove_customization.*) COMPREPLY=( $(compgen -W '--> [Account] [Account,Id] [Account,Ids] [_Account,[]] ' -- $cur) ) ;;
            .sup.teletype_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.teletype_maintenance.receipts.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.teletype_maintenance.list_templates_from_db.*) COMPREPLY=( $(compgen -W '--> [Db] ' -- $cur) ) ;;
            .sup.teletype_maintenance.force_system_default.*) COMPREPLY=( $(compgen -W '--> [Account] [Account,Id] [Account,Ids] [_Account,[]] ' -- $cur) ) ;;
            .sup.blackhole_maintenance.stop_module.*) COMPREPLY=( $(compgen -W '--> [ModuleBin] [ModuleBin,Persist] ' -- $cur) ) ;;
            .sup.blackhole_maintenance.start_module.*) COMPREPLY=( $(compgen -W '--> [ModuleBin] [ModuleBin,Persist] ' -- $cur) ) ;;
            .sup.blackhole_maintenance.running_modules.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.conference_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] [_Account] ' -- $cur) ) ;;
            .sup.conference_maintenance.blocking_refresh.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.registrar_maintenance.set_listeners.*) COMPREPLY=( $(compgen -W '--> [Count] ' -- $cur) ) ;;
            .sup.registrar_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.registrar_maintenance.device_by_ip.*) COMPREPLY=( $(compgen -W '--> [IP] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.set_failure_expiry.*) COMPREPLY=( $(compgen -W '--> [Expires] [Account,Expires] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.set_disable_threshold.*) COMPREPLY=( $(compgen -W '--> [Count] [Account,Count] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.hooks_configured.*) COMPREPLY=( $(compgen -W '--> [] [AccountId] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.flush_hook_failures.*) COMPREPLY=( $(compgen -W '--> [AccountId,HookId] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.flush_account_failures.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.failure_status.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.enable_descendant_hooks.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.webhooks_maintenance.enable_account_hooks.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.acdc_maintenance.refresh_account.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.acdc_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.acdc_maintenance.queues_summary.*) COMPREPLY=( $(compgen -W '--> [] [AcctId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.queues_restart.*) COMPREPLY=( $(compgen -W '--> [AcctId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.queues_detail.*) COMPREPLY=( $(compgen -W '--> [] [AcctId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.queue_summary.*) COMPREPLY=( $(compgen -W '--> [AcctId,QueueId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.queue_restart.*) COMPREPLY=( $(compgen -W '--> [AcctId,QueueId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.queue_detail.*) COMPREPLY=( $(compgen -W '--> [AcctId,QueueId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.migrate_to_acdc_db.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.acdc_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.acdc_maintenance.logout_agents.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.logout_agent.*) COMPREPLY=( $(compgen -W '--> [AccountId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.flush_call_stat.*) COMPREPLY=( $(compgen -W '--> [CallId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.current_statuses.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.current_queues.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.current_calls.*) COMPREPLY=( $(compgen -W '--> [AccountId] [AccountId,Props] [AccountId,QueueId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.current_agents.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agents_summary.*) COMPREPLY=( $(compgen -W '--> [] [AcctId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agents_detail.*) COMPREPLY=( $(compgen -W '--> [] [AcctId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_summary.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_resume.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_queue_logout.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId,QueueId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_queue_login.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId,QueueId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_presence_id.*) COMPREPLY=( $(compgen -W '--> [AccountId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_pause.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId] [AcctId,AgentId,Timeout] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_logout.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_login.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_maintenance.agent_detail.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_agent_maintenance.status.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.acdc_agent_maintenance.agent_status.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_agent_maintenance.agent_restart.*) COMPREPLY=( $(compgen -W '--> [AcctId,AgentId] ' -- $cur) ) ;;
            .sup.acdc_agent_maintenance.acct_status.*) COMPREPLY=( $(compgen -W '--> [AcctId] ' -- $cur) ) ;;
            .sup.acdc_agent_maintenance.acct_restart.*) COMPREPLY=( $(compgen -W '--> [AcctId] ' -- $cur) ) ;;
            .sup.doodle_maintenance.start_check_sms_by_owner_id.*) COMPREPLY=( $(compgen -W '--> [AccountId,OwnerId] ' -- $cur) ) ;;
            .sup.doodle_maintenance.start_check_sms_by_device_id.*) COMPREPLY=( $(compgen -W '--> [AccountId,DeviceId] ' -- $cur) ) ;;
            .sup.doodle_maintenance.start_check_sms_by_account.*) COMPREPLY=( $(compgen -W '--> [AccountId,JObj] ' -- $cur) ) ;;
            .sup.doodle_maintenance.send_outbound_sms.*) COMPREPLY=( $(compgen -W '--> [To,Msg] [To,Msg,Times] [To,From,RouteId,Msg] [To,From,RouteId,Msg,Times] ' -- $cur) ) ;;
            .sup.doodle_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.doodle_maintenance.check_sms_by_owner_id.*) COMPREPLY=( $(compgen -W '--> [AccountId,OwnerId] [_AccountId,'undefined'] ' -- $cur) ) ;;
            .sup.doodle_maintenance.check_sms_by_device_id.*) COMPREPLY=( $(compgen -W '--> [AccountId,DeviceId] [_AccountId,'undefined'] ' -- $cur) ) ;;
            .sup.doodle_maintenance.check_pending_sms_for_outbound_delivery.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.doodle_maintenance.check_pending_sms_for_delivery.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.braintree_maintenance.sync_payment_info.*) COMPREPLY=( $(compgen -W '--> [AccountId,CardId] ' -- $cur) ) ;;
            .sup.braintree_maintenance.sync_all_accounts_payments_info.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.braintree_maintenance.sync_account_services_payments_info.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.tasks_maintenance.tasks.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.tasks_maintenance.task_output.*) COMPREPLY=( $(compgen -W '--> [TaskId] ' -- $cur) ) ;;
            .sup.tasks_maintenance.task_input.*) COMPREPLY=( $(compgen -W '--> [TaskId] ' -- $cur) ) ;;
            .sup.tasks_maintenance.task.*) COMPREPLY=( $(compgen -W '--> [TaskId] ' -- $cur) ) ;;
            .sup.tasks_maintenance.start_cleanup_pass.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.tasks_maintenance.start.*) COMPREPLY=( $(compgen -W '--> [TaskId] ' -- $cur) ) ;;
            .sup.tasks_maintenance.restart.*) COMPREPLY=( $(compgen -W '--> [TaskId] ' -- $cur) ) ;;
            .sup.tasks_maintenance.remove.*) COMPREPLY=( $(compgen -W '--> [TaskId] ' -- $cur) ) ;;
            .sup.tasks_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.tasks_maintenance.help.*) COMPREPLY=( $(compgen -W '--> [] [Category] [Category,Action] ' -- $cur) ) ;;
            .sup.tasks_maintenance.compaction.*) COMPREPLY=( $(compgen -W '--> [history] [status] [compact_db,Db] [compact_node,Node] [history,JobId] [history,PLACEHOLDER] ' -- $cur) ) ;;
            .sup.tasks_maintenance.cleanup_soft_deletes.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.tasks_maintenance.add.*) COMPREPLY=( $(compgen -W '--> [AuthAccount,Account,Category,Action] [AuthAccount,Account,Category,Action,CSVFile] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.statistics.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.send_notify.*) COMPREPLY=( $(compgen -W '--> [Id] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.pending_by_type.*) COMPREPLY=( $(compgen -W '--> [Type] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.pending.*) COMPREPLY=( $(compgen -W '--> [] [ShowCount] [ShowCount,"true"] [ShowCount,_Details] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.notify_info.*) COMPREPLY=( $(compgen -W '--> [Id] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.failed_by_type.*) COMPREPLY=( $(compgen -W '--> [Type] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.failed.*) COMPREPLY=( $(compgen -W '--> [] [ShowCount] [ShowCount,"true"] [ShowCount,_Details] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.delete_older_than.*) COMPREPLY=( $(compgen -W '--> [Timestamp] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.delete_between.*) COMPREPLY=( $(compgen -W '--> [StartTimestamp,EndTimestamp] ' -- $cur) ) ;;
            .sup.notify_resend_maintenance.delete.*) COMPREPLY=( $(compgen -W '--> [Id] ' -- $cur) ) ;;
            .sup.hangups_maintenance.set_threshold.*) COMPREPLY=( $(compgen -W '--> [HangupCause,Metric,LoadAvg] [AccountId,HangupCause,Metric,LoadAvg] ' -- $cur) ) ;;
            .sup.hangups_maintenance.set_monitor_threshold.*) COMPREPLY=( $(compgen -W '--> [HangupCause,TOM] [HangupCause,ThresholdName,T] ' -- $cur) ) ;;
            .sup.hangups_maintenance.set_metric.*) COMPREPLY=( $(compgen -W '--> [Metric,LoadAvg] [AccountId,Metric,LoadAvg] ' -- $cur) ) ;;
            .sup.hangups_maintenance.hangups_summary.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.hangups_maintenance.hangup_summary.*) COMPREPLY=( $(compgen -W '--> [HangupCause] [HangupCause,AccountId] ' -- $cur) ) ;;
            .sup.hangups_maintenance.activate_monitors.*) COMPREPLY=( $(compgen -W '--> [AccountId,ThresholdOneMinute] ' -- $cur) ) ;;
            .sup.hangups_maintenance.activate_monitor.*) COMPREPLY=( $(compgen -W '--> [AccountId,HangupCause] ' -- $cur) ) ;;
            .sup.hangups_maintenance.account_summary.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.media_mgr_maintenance.prompt_url.*) COMPREPLY=( $(compgen -W '--> [PromptId] [PromptId,AccountId] [PromptId,AccountId,Language] ' -- $cur) ) ;;
            .sup.konami_maintenance.is_running.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.konami_maintenance.add_default_metaflow.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.konami_maintenance.add_default_account_metaflow.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.pusher_maintenance.add_google_app.*) COMPREPLY=( $(compgen -W '--> [AppId,Secret] ' -- $cur) ) ;;
            .sup.pusher_maintenance.add_apple_app.*) COMPREPLY=( $(compgen -W '--> [AppId,Certfile] [AppId,Certfile,Host] ' -- $cur) ) ;;
            .sup.hotornot_maintenance.trie_rebuild.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.hotornot_maintenance.set_rate_version.*) COMPREPLY=( $(compgen -W '--> [Version] ' -- $cur) ) ;;
            .sup.hotornot_maintenance.rates_for_did.*) COMPREPLY=( $(compgen -W '--> [DID] [DID,AccountId] [DID,Direction,RouteOptions] [DID,Direction,AccountId,Opt] [DID,Direction,AccountId,RouteOptions] ' -- $cur) ) ;;
            .sup.hotornot_maintenance.rates_between.*) COMPREPLY=( $(compgen -W '--> [Pre,Post] ' -- $cur) ) ;;
            .sup.hotornot_maintenance.local_summary.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.hotornot_maintenance.get_rate_version.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.callflow_maintenance.update_feature_codes.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.callflow_maintenance.show_calls.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.callflow_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.callflow_maintenance.migrate_recorded_names.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.callflow_maintenance.migrate_recorded_name.*) COMPREPLY=( $(compgen -W '--> [Db] ' -- $cur) ) ;;
            .sup.callflow_maintenance.migrate_menus.*) COMPREPLY=( $(compgen -W '--> [] [Account] ' -- $cur) ) ;;
            .sup.callflow_maintenance.lookup_endpoint.*) COMPREPLY=( $(compgen -W '--> [URI] [Username,Realm] ' -- $cur) ) ;;
            .sup.callflow_maintenance.list_account_restrictions.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.callflow_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.callflow_maintenance.enable_authz_contexts.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.callflow_maintenance.disable_authz_contexts.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.callflow_maintenance.device_classifier_inherit.*) COMPREPLY=( $(compgen -W '--> [Classifier,Uri] ' -- $cur) ) ;;
            .sup.callflow_maintenance.device_classifier_deny.*) COMPREPLY=( $(compgen -W '--> [Classifier,Uri] ' -- $cur) ) ;;
            .sup.callflow_maintenance.deny_authz_context.*) COMPREPLY=( $(compgen -W '--> [App] ' -- $cur) ) ;;
            .sup.callflow_maintenance.call_count.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.callflow_maintenance.blocking_refresh.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.callflow_maintenance.allow_authz_context.*) COMPREPLY=( $(compgen -W '--> [App] [App,DefaultContext] ' -- $cur) ) ;;
            .sup.callflow_maintenance.all_accounts_set_classifier_inherit.*) COMPREPLY=( $(compgen -W '--> [Classifier] ' -- $cur) ) ;;
            .sup.callflow_maintenance.all_accounts_set_classifier_deny.*) COMPREPLY=( $(compgen -W '--> [Classifier] ' -- $cur) ) ;;
            .sup.callflow_maintenance.account_set_classifier_inherit.*) COMPREPLY=( $(compgen -W '--> [Classifier,Account] ' -- $cur) ) ;;
            .sup.callflow_maintenance.account_set_classifier_deny.*) COMPREPLY=( $(compgen -W '--> [Classifier,Account] ' -- $cur) ) ;;
            .sup.crossbar_bindings.succeeded.*) COMPREPLY=( $(compgen -W '--> [Res] ' -- $cur) ) ;;
            .sup.crossbar_bindings.start_link.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_bindings.pmap.*) COMPREPLY=( $(compgen -W '--> [Routing,Payload] ' -- $cur) ) ;;
            .sup.crossbar_bindings.modules_loaded.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_bindings.matches.*) COMPREPLY=( $(compgen -W '--> [[R|Restrictions],Tokens] [[],_] ' -- $cur) ) ;;
            .sup.crossbar_bindings.map.*) COMPREPLY=( $(compgen -W '--> [Routing,Payload] ' -- $cur) ) ;;
            .sup.crossbar_bindings.init.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_bindings.fold.*) COMPREPLY=( $(compgen -W '--> [Routing,Payload] ' -- $cur) ) ;;
            .sup.crossbar_bindings.flush_mod.*) COMPREPLY=( $(compgen -W '--> [CBMod] ' -- $cur) ) ;;
            .sup.crossbar_bindings.flush.*) COMPREPLY=( $(compgen -W '--> [] [Binding] ' -- $cur) ) ;;
            .sup.crossbar_bindings.failed.*) COMPREPLY=( $(compgen -W '--> [Res] ' -- $cur) ) ;;
            .sup.crossbar_bindings.bind.*) COMPREPLY=( $(compgen -W '--> [PLACEHOLDER,Module,Fun] ' -- $cur) ) ;;
            .sup.crossbar_bindings.any.*) COMPREPLY=( $(compgen -W '--> [Res] ' -- $cur) ) ;;
            .sup.crossbar_bindings.all.*) COMPREPLY=( $(compgen -W '--> [Res] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.update_schemas.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.stop_module.*) COMPREPLY=( $(compgen -W '--> [Module] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.start_module.*) COMPREPLY=( $(compgen -W '--> [Module] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.set_app_screenshots.*) COMPREPLY=( $(compgen -W '--> [AppId,PathToScreenshotsFolder] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.set_app_label.*) COMPREPLY=( $(compgen -W '--> [AppId,Value] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.set_app_icon.*) COMPREPLY=( $(compgen -W '--> [AppId,PathToPNGIcon] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.set_app_field.*) COMPREPLY=( $(compgen -W '--> [AppId,Field,Value] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.set_app_features.*) COMPREPLY=( $(compgen -W '--> [AppId,Value] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.set_app_extended_description.*) COMPREPLY=( $(compgen -W '--> [AppId,Value] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.set_app_description.*) COMPREPLY=( $(compgen -W '--> [AppId,Value] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.running_modules.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.register_views.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.refresh_apps.*) COMPREPLY=( $(compgen -W '--> [AppsPath] [AppsPath,AppUrl] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.refresh_app.*) COMPREPLY=( $(compgen -W '--> [AppPath] [AppPath,AppUrl] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.refresh.*) COMPREPLY=( $(compgen -W '--> [] [Value] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.promote_account.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.move_account.*) COMPREPLY=( $(compgen -W '--> [Account,ToAccount] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.migrate_ring_group_callflow.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.migrate_accounts_data.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.migrate_account_data.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [] [Accounts] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.init_apps.*) COMPREPLY=( $(compgen -W '--> [AppsPath] [AppsPath,AppUrl] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.init_app.*) COMPREPLY=( $(compgen -W '--> [AppPath] [AppPath,AppUrl] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.flush.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.find_account_by_realm.*) COMPREPLY=( $(compgen -W '--> [Realm] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.find_account_by_number.*) COMPREPLY=( $(compgen -W '--> [Number] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.find_account_by_name.*) COMPREPLY=( $(compgen -W '--> [Name] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.find_account_by_id.*) COMPREPLY=( $(compgen -W '--> [Id] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.enable_account.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.does_schema_exist.*) COMPREPLY=( $(compgen -W '--> [Schema] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.disallow_account_number_additions.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.disable_account.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.descendants_count.*) COMPREPLY=( $(compgen -W '--> [] [AccountId] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.demote_account.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.db_init.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.create_account.*) COMPREPLY=( $(compgen -W '--> [Context] [AccountName,Realm,Username,Password] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.apps.*) COMPREPLY=( $(compgen -W '--> [] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.app.*) COMPREPLY=( $(compgen -W '--> [AppNameOrId] ' -- $cur) ) ;;
            .sup.crossbar_maintenance.allow_account_number_additions.*) COMPREPLY=( $(compgen -W '--> [AccountId] ' -- $cur) ) ;;
            .sup.cb_apps_maintenance.migrate.*) COMPREPLY=( $(compgen -W '--> [Account] ' -- $cur) ) ;;
        esac
    }

    case $prev in

        sup) COMPREPLY=( $(compgen -W 'kazoo_voicemail_maintenance kazoo_media_maintenance kazoo_convert_maintenance kazoo_proper_maintenance kazoo_auth_maintenance kazoo_endpoint_maintenance kazoo_ledgers_maintenance kazoo_schemas_maintenance kazoo_services_maintenance kazoo_speech_maintenance kazoo_perf_maintenance kazoo_oauth_maintenance kazoo_maintenance kazoo_modb_migrate_maintenance kazoo_modb_maintenance kapps_controller kapps_maintenance kapps_account_config kapps_config kazoo_apps_maintenance kazoo_ips_maintenance kazoo_data_maintenance kazoo_number_manager_maintenance kazoo_amqp_maintenance omnipresence_maintenance ecallmgr_maintenance fax_maintenance jonny5_maintenance frontier_maintenance call_inspector_maintenance stepswitch_maintenance edr_maintenance notify_maintenance trunkstore_maintenance teletype_maintenance blackhole_maintenance conference_maintenance registrar_maintenance webhooks_maintenance acdc_maintenance acdc_agent_maintenance doodle_maintenance braintree_maintenance tasks_maintenance notify_resend_maintenance hangups_maintenance media_mgr_maintenance konami_maintenance pusher_maintenance hotornot_maintenance callflow_maintenance crossbar_bindings crossbar_maintenance cb_apps_maintenance ' -- $cur) ) ;;

        kazoo_voicemail_maintenance)
            case $path in
                .sup.kazoo_voicemail_maintenance.*) COMPREPLY=( $(compgen -W 'migrate recover_messages_account recover_messages_all recover_messages_month renotify ' -- $cur) ) ;;
            esac ;;
        kazoo_media_maintenance)
            case $path in
                .sup.kazoo_media_maintenance.*) COMPREPLY=( $(compgen -W 'fix_media_names import_prompt import_prompts migrate migrate_prompts refresh register_views remove_empty_media_docs set_account_language ' -- $cur) ) ;;
            esac ;;
        kazoo_convert_maintenance)
            case $path in
                .sup.kazoo_convert_maintenance.*) COMPREPLY=( $(compgen -W 'convert_fax_file read_metadata read_tiff_info versions_in_use ' -- $cur) ) ;;
            esac ;;
        kazoo_proper_maintenance)
            case $path in
                .sup.kazoo_proper_maintenance.*) COMPREPLY=( $(compgen -W 'run_module run_modules run_seq_module run_seq_modules ' -- $cur) ) ;;
            esac ;;
        kazoo_auth_maintenance)
            case $path in
                .sup.kazoo_auth_maintenance.*) COMPREPLY=( $(compgen -W 'ensure_secret flush refresh register_auth_app register_auth_app_key register_common_providers register_views ' -- $cur) ) ;;
            esac ;;
        kazoo_endpoint_maintenance)
            case $path in
                .sup.kazoo_endpoint_maintenance.*) COMPREPLY=( $(compgen -W 'flush ' -- $cur) ) ;;
            esac ;;
        kazoo_ledgers_maintenance)
            case $path in
                .sup.kazoo_ledgers_maintenance.*) COMPREPLY=( $(compgen -W 'current_rollovers fix_rollover fix_rollovers rollover_account rollover_accounts verify_all_rollovers verify_rollovers ' -- $cur) ) ;;
            esac ;;
        kazoo_schemas_maintenance)
            case $path in
                .sup.kazoo_schemas_maintenance.*) COMPREPLY=( $(compgen -W 'diff_schema diff_schemas ' -- $cur) ) ;;
            esac ;;
        kazoo_services_maintenance)
            case $path in
                .sup.kazoo_services_maintenance.*) COMPREPLY=( $(compgen -W 'attempt_services_recovery cascade_reseller_id db_init demote_reseller disable_topup enable_topup fix_plan_apps flush get_accounts_by_depth get_accounts_with_plans make_reseller migrate_service_plan migrate_service_plans migrate_services rebuild_services_db reconcile refresh register_views remove_orphaned_services set_reseller_id sync sync_descendants topup_status update_tree ' -- $cur) ) ;;
            esac ;;
        kazoo_speech_maintenance)
            case $path in
                .sup.kazoo_speech_maintenance.*) COMPREPLY=( $(compgen -W 'set_tts_api_key set_tts_language set_tts_provider ' -- $cur) ) ;;
            esac ;;
        kazoo_perf_maintenance)
            case $path in
                .sup.kazoo_perf_maintenance.*) COMPREPLY=( $(compgen -W 'graphite_metrics json_metrics ' -- $cur) ) ;;
            esac ;;
        kazoo_oauth_maintenance)
            case $path in
                .sup.kazoo_oauth_maintenance.*) COMPREPLY=( $(compgen -W 'code_change handle_call handle_cast handle_info init refresh register_common_providers register_oauth_app start_link stop terminate ' -- $cur) ) ;;
            esac ;;
        kazoo_maintenance)
            case $path in
                .sup.kazoo_maintenance.*) COMPREPLY=( $(compgen -W 'console_level crash debug_dump error_level etop ets_info gc_all gc_pids gc_top_mem_consumers hotload hotload_app mem_info syslog_level top_mem_consumers ' -- $cur) ) ;;
            esac ;;
        kazoo_modb_migrate_maintenance)
            case $path in
                .sup.kazoo_modb_migrate_maintenance.*) COMPREPLY=( $(compgen -W 'migrate migrate_account migrate_cdrs migrate_voicemails ' -- $cur) ) ;;
            esac ;;
        kazoo_modb_maintenance)
            case $path in
                .sup.kazoo_modb_maintenance.*) COMPREPLY=( $(compgen -W 'archive_modbs delete_modbs register_views ' -- $cur) ) ;;
            esac ;;
        kapps_controller)
            case $path in
                .sup.kapps_controller.*) COMPREPLY=( $(compgen -W 'binding_fetch_app list_apps ready restart_app running_apps start_app start_default_apps start_link start_which_kapps stop_app unbinding_fetch_app ' -- $cur) ) ;;
            esac ;;
        kapps_maintenance)
            case $path in
                .sup.kapps_maintenance.*) COMPREPLY=( $(compgen -W 'bind bind_and_register_views binding call_id_status check_release check_system_config check_system_configs cleanup_aggregated_account cleanup_aggregated_accounts cleanup_aggregated_device cleanup_aggregated_devices cleanup_orphan_modbs cleanup_system_config cleanup_system_configs cleanup_voicemail_media ensure_aggregate ensure_aggregate_account ensure_aggregate_accounts ensure_aggregate_device ensure_aggregate_devices ensure_aggregate_faxbox ensure_aggregate_faxboxes ensure_aggregates ensure_reseller_id_account ensure_reseller_id_accounts ensure_reseller_id_services ensure_tree_account ensure_tree_account_dry_run ensure_tree_accounts ensure_tree_accounts_dry_run find_invalid_acccount_dbs flush_account_views flush_getby_cache get_all_account_views import_account init_system maybe_delete_db migrate migrate_limits migrate_media migrate_modbs migrate_modbs_ranged migrate_system migrate_to_4_0 parallel_migrate parallel_migrate_modbs parallel_migrate_modbs_ranged purge_doc_type read_all_account_views rebuild_db refresh refresh_account refresh_account_db refresh_system_views register_account_views register_system_dbs_views register_views remove_aggregated_account remove_deprecated_databases unbind validate_system_config validate_system_configs ' -- $cur) ) ;;
            esac ;;
        kapps_account_config)
            case $path in
                .sup.kapps_account_config.*) COMPREPLY=( $(compgen -W 'flush flush_all_strategies get get_from_reseller get_global get_hierarchy get_ne_binaries get_ne_binary get_pos_integer get_with_strategy migrate set set_global ' -- $cur) ) ;;
            esac ;;
        kapps_config)
            case $path in
                .sup.kapps_config.*) COMPREPLY=( $(compgen -W 'fetch_category fetch_current flush get get_all_kvs get_atom get_binary get_boolean get_category get_current get_float get_integer get_is_false get_is_true get_json get_jsons get_ne_binaries get_ne_binary get_ne_binary_or_ne_binaries get_node_value get_non_neg_integer get_pos_integer get_string is_locked is_true lock_db migrate set set_boolean set_default set_float set_integer set_json set_node set_string update_default ' -- $cur) ) ;;
            esac ;;
        kazoo_apps_maintenance)
            case $path in
                .sup.kazoo_apps_maintenance.*) COMPREPLY=( $(compgen -W 'check make_autostart_distinct ready restart start stop ' -- $cur) ) ;;
            esac ;;
        kazoo_ips_maintenance)
            case $path in
                .sup.kazoo_ips_maintenance.*) COMPREPLY=( $(compgen -W 'add assign delete refresh release summary ' -- $cur) ) ;;
            esac ;;
        kazoo_data_maintenance)
            case $path in
                .sup.kazoo_data_maintenance.*) COMPREPLY=( $(compgen -W 'cache_strategy dataplan_reload flush flush_data_plans flush_docs load_doc_from_file open_document open_document_cached set_cache_strategy stop_trace trace_function trace_module trace_pid ' -- $cur) ) ;;
            esac ;;
        kazoo_number_manager_maintenance)
            case $path in
                .sup.kazoo_number_manager_maintenance.*) COMPREPLY=( $(compgen -W 'add_allowed_feature_on_number add_allowed_feature_on_reseller_of add_allowed_feature_on_system_config add_denied_feature_on_number add_denied_feature_on_reseller_of all_features app_using carrier_module_usage convert_carrier_module convert_carrier_module_number copy_accounts_to_number_dbs copy_assigned_number_dbs_to_account copy_number_dbs_to_accounts copy_single_account_to_number_dbs copy_single_assigned_number_db_to_account copy_single_number_db_to_accounts copy_single_number_to_account_db delete ensure_adminonly_features_are_reachable feature_permissions_on_number feature_permissions_on_reseller_of feature_permissions_on_system_config fix_account_db_numbers fix_apps_for_account_dbs fix_apps_for_number_dbs fix_apps_for_single_account_db fix_apps_for_single_number_db fix_apps_in_number_dbs_for_accounts fix_apps_in_number_dbs_for_single_account generate_js_classifiers generate_numbers init_dbs migrate migrate_port_requests migrate_unassigned_numbers purge_deleted purge_discovery refresh_numbers_db refresh_numbers_dbs register_views remove_allowed_feature_on_number remove_allowed_feature_on_reseller_of remove_allowed_feature_on_system_config remove_denied_feature_on_number remove_denied_feature_on_reseller_of remove_wrong_assigned_from_accounts remove_wrong_assigned_from_single_accountdb reset_allowed_features_to_defaults_on_system_config update_number_services_view ' -- $cur) ) ;;
            esac ;;
        kazoo_amqp_maintenance)
            case $path in
                .sup.kazoo_amqp_maintenance.*) COMPREPLY=( $(compgen -W 'add_broker add_connection broker_summary channel_summary connection_summary consumer_details gc_pool gc_pools primary_broker remove_broker validate_assignments ' -- $cur) ) ;;
            esac ;;
        omnipresence_maintenance)
            case $path in
                .sup.omnipresence_maintenance.*) COMPREPLY=( $(compgen -W 'count_current_subscriptions current_subscriptions reset_account reset_cluster reset_realm reset_server reset_subscriber reset_subscription reset_zone send_mwi_update subscribe ' -- $cur) ) ;;
            esac ;;
        ecallmgr_maintenance)
            case $path in
                .sup.ecallmgr_maintenance.*) COMPREPLY=( $(compgen -W 'acl_summary add_fs_node allow_carrier allow_sbc carrier_acls channel_details channel_summary check_sync conference_details conference_summary deny_carrier deny_sbc disable_authz disable_local_resource_authz enable_authz enable_local_resource_authz flush_acls flush_authn flush_node_channels flush_node_conferences flush_registrar flush_util get_fs_nodes hangup_long_running_channels limit_channel_uptime list_fs_nodes node_details node_summary registrar_details registrar_summary registrar_sync reload_acls remove_acl remove_fs_node sbc_acls show_calls show_channels sync_channels sync_conferences test_carrier_ip test_sbc_ip ' -- $cur) ) ;;
            esac ;;
        fax_maintenance)
            case $path in
                .sup.fax_maintenance.*) COMPREPLY=( $(compgen -W 'account_jobs active_jobs faxbox_jobs flush load_smtp_attachment migrate migrate_outbound_faxes pending_jobs refresh_views restart_job update_job ' -- $cur) ) ;;
            esac ;;
        jonny5_maintenance)
            case $path in
                .sup.jonny5_maintenance.*) COMPREPLY=( $(compgen -W 'authz_details authz_summary flush flush_channels limits_details limits_summary ' -- $cur) ) ;;
            esac ;;
        frontier_maintenance)
            case $path in
                .sup.frontier_maintenance.*) COMPREPLY=( $(compgen -W 'lookup_acls lookup_rate_limits update_system_default ' -- $cur) ) ;;
            esac ;;
        call_inspector_maintenance)
            case $path in
                .sup.call_inspector_maintenance.*) COMPREPLY=( $(compgen -W 'callid_details flush inspect_call_id list_active_parsers start_freeswitch_parser start_hep_parser start_kamailio_parser stop_active_parser ' -- $cur) ) ;;
            esac ;;
        stepswitch_maintenance)
            case $path in
                .sup.stepswitch_maintenance.*) COMPREPLY=( $(compgen -W 'cnam_flush flush lookup_number number_tree process_number register_views reload_resources resources reverse_lookup ' -- $cur) ) ;;
            esac ;;
        edr_maintenance)
            case $path in
                .sup.edr_maintenance.*) COMPREPLY=( $(compgen -W 'delete_backend disable_backend enable_backend register_backend registered_backends restart_backend ' -- $cur) ) ;;
            esac ;;
        notify_maintenance)
            case $path in
                .sup.notify_maintenance.*) COMPREPLY=( $(compgen -W 'check_initial_call check_initial_registration configure_smtp_auth configure_smtp_password configure_smtp_port configure_smtp_relay configure_smtp_username refresh refresh_template reload_smtp_configs ' -- $cur) ) ;;
            esac ;;
        trunkstore_maintenance)
            case $path in
                .sup.trunkstore_maintenance.*) COMPREPLY=( $(compgen -W 'classifier_deny classifier_inherit clear_old_calls flush ' -- $cur) ) ;;
            esac ;;
        teletype_maintenance)
            case $path in
                .sup.teletype_maintenance.*) COMPREPLY=( $(compgen -W 'force_system_default list_templates_from_db receipts register_views remove_customization renderer_status restore_system_template restore_system_templates start_module stop_module ' -- $cur) ) ;;
            esac ;;
        blackhole_maintenance)
            case $path in
                .sup.blackhole_maintenance.*) COMPREPLY=( $(compgen -W 'running_modules start_module stop_module ' -- $cur) ) ;;
            esac ;;
        conference_maintenance)
            case $path in
                .sup.conference_maintenance.*) COMPREPLY=( $(compgen -W 'blocking_refresh refresh ' -- $cur) ) ;;
            esac ;;
        registrar_maintenance)
            case $path in
                .sup.registrar_maintenance.*) COMPREPLY=( $(compgen -W 'device_by_ip register_views set_listeners ' -- $cur) ) ;;
            esac ;;
        webhooks_maintenance)
            case $path in
                .sup.webhooks_maintenance.*) COMPREPLY=( $(compgen -W 'enable_account_hooks enable_descendant_hooks failure_status flush_account_failures flush_hook_failures hooks_configured register_views set_disable_threshold set_failure_expiry ' -- $cur) ) ;;
            esac ;;
        acdc_maintenance)
            case $path in
                .sup.acdc_maintenance.*) COMPREPLY=( $(compgen -W 'agent_detail agent_login agent_logout agent_pause agent_presence_id agent_queue_login agent_queue_logout agent_resume agent_summary agents_detail agents_summary current_agents current_calls current_queues current_statuses flush_call_stat logout_agent logout_agents migrate migrate_to_acdc_db queue_detail queue_restart queue_summary queues_detail queues_restart queues_summary refresh refresh_account register_views ' -- $cur) ) ;;
            esac ;;
        acdc_agent_maintenance)
            case $path in
                .sup.acdc_agent_maintenance.*) COMPREPLY=( $(compgen -W 'acct_restart acct_status agent_restart agent_status status ' -- $cur) ) ;;
            esac ;;
        doodle_maintenance)
            case $path in
                .sup.doodle_maintenance.*) COMPREPLY=( $(compgen -W 'check_pending_sms_for_delivery check_pending_sms_for_outbound_delivery check_sms_by_device_id check_sms_by_owner_id flush send_outbound_sms start_check_sms_by_account start_check_sms_by_device_id start_check_sms_by_owner_id ' -- $cur) ) ;;
            esac ;;
        braintree_maintenance)
            case $path in
                .sup.braintree_maintenance.*) COMPREPLY=( $(compgen -W 'sync_account_services_payments_info sync_all_accounts_payments_info sync_payment_info ' -- $cur) ) ;;
            esac ;;
        tasks_maintenance)
            case $path in
                .sup.tasks_maintenance.*) COMPREPLY=( $(compgen -W 'add cleanup_soft_deletes compaction help register_views remove restart start start_cleanup_pass task task_input task_output tasks ' -- $cur) ) ;;
            esac ;;
        notify_resend_maintenance)
            case $path in
                .sup.notify_resend_maintenance.*) COMPREPLY=( $(compgen -W 'delete delete_between delete_older_than failed failed_by_type notify_info pending pending_by_type send_notify statistics ' -- $cur) ) ;;
            esac ;;
        hangups_maintenance)
            case $path in
                .sup.hangups_maintenance.*) COMPREPLY=( $(compgen -W 'account_summary activate_monitor activate_monitors hangup_summary hangups_summary set_metric set_monitor_threshold set_threshold ' -- $cur) ) ;;
            esac ;;
        media_mgr_maintenance)
            case $path in
                .sup.media_mgr_maintenance.*) COMPREPLY=( $(compgen -W 'prompt_url ' -- $cur) ) ;;
            esac ;;
        konami_maintenance)
            case $path in
                .sup.konami_maintenance.*) COMPREPLY=( $(compgen -W 'add_default_account_metaflow add_default_metaflow is_running ' -- $cur) ) ;;
            esac ;;
        pusher_maintenance)
            case $path in
                .sup.pusher_maintenance.*) COMPREPLY=( $(compgen -W 'add_apple_app add_google_app ' -- $cur) ) ;;
            esac ;;
        hotornot_maintenance)
            case $path in
                .sup.hotornot_maintenance.*) COMPREPLY=( $(compgen -W 'get_rate_version local_summary rates_between rates_for_did set_rate_version trie_rebuild ' -- $cur) ) ;;
            esac ;;
        callflow_maintenance)
            case $path in
                .sup.callflow_maintenance.*) COMPREPLY=( $(compgen -W 'account_set_classifier_deny account_set_classifier_inherit all_accounts_set_classifier_deny all_accounts_set_classifier_inherit allow_authz_context blocking_refresh call_count deny_authz_context device_classifier_deny device_classifier_inherit disable_authz_contexts enable_authz_contexts flush list_account_restrictions lookup_endpoint migrate_menus migrate_recorded_name migrate_recorded_names refresh show_calls update_feature_codes ' -- $cur) ) ;;
            esac ;;
        crossbar_bindings)
            case $path in
                .sup.crossbar_bindings.*) COMPREPLY=( $(compgen -W 'all any bind failed flush flush_mod fold init map matches modules_loaded pmap start_link succeeded ' -- $cur) ) ;;
            esac ;;
        crossbar_maintenance)
            case $path in
                .sup.crossbar_maintenance.*) COMPREPLY=( $(compgen -W 'allow_account_number_additions app apps create_account db_init demote_account descendants_count disable_account disallow_account_number_additions does_schema_exist enable_account find_account_by_id find_account_by_name find_account_by_number find_account_by_realm flush init_app init_apps migrate migrate_account_data migrate_accounts_data migrate_ring_group_callflow move_account promote_account refresh refresh_app refresh_apps register_views running_modules set_app_description set_app_extended_description set_app_features set_app_field set_app_icon set_app_label set_app_screenshots start_module stop_module update_schemas ' -- $cur) ) ;;
            esac ;;
        cb_apps_maintenance)
            case $path in
                .sup.cb_apps_maintenance.*) COMPREPLY=( $(compgen -W 'migrate ' -- $cur) ) ;;
            esac ;;

        *) args ;;
    esac
}
complete -F _sup sup
